> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.ninjatrader.com/marketplace/rest-api-endpoints/products/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.ninjatrader.com/_mcp/server. # products POST https://ecosystemapi.ninjatrader.com/v1/products Content-Type: application/json Insert products. Reference: https://docs.ninjatrader.com/marketplace/rest-api-endpoints/products ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Servers - `https://ecosystemapi.ninjatrader.com/v1` (production, default) - `https://ecosystemapi-d.ninjatrader.com/v1` (development) ## Request ### Body (application/json) This endpoint expects a CreateProductRequest. - `product` (CreateProductRequestProduct, required) ## Response ### 200 Default Response - `result` (double, required, nullable) - `errorText` (string, required) — ErrorMessage ## Errors ### 400 Bad Request Error Bad Request - The request was invalid or cannot be served - `statusCode` (double, required) - `error` (string, required) - `requestId` (string, required) ### 401 Unauthorized Error Unauthorized - Authentication is required or failed - `statusCode` (double, required) - `error` (string, required) - `requestId` (string, required) ### 403 Forbidden Error Forbidden - The request was understood but refused - `statusCode` (double, required) - `error` (string, required) - `requestId` (string, required) ### 404 Not Found Error Not Found - The requested resource does not exist - `statusCode` (double, required) - `error` (string, required) - `requestId` (string, required) ### 500 Internal Server Error Internal Server Error - An unexpected error occurred - `statusCode` (double, required) - `error` (string, required) - `requestId` (string, required) ## Types ### CreateProductRequestProduct - `name` (string, required) - `description` (string, required) - `category` (enum, required) - Allowed values: `Desktop` - `type` (enum, required) - Allowed values: `PublicOpenSource`, `PublicProtected`, `PublicInviteOnly`, `PrivateInviteOnly` - `freeTrialExpirationDays` (integer, required, nullable) - `isActive` (boolean, required) ## Examples **Request** ```json { "product": { "name": "Loretta Goldner", "description": "Hearty marigold and ostrich stew, slow-cooked with spearmint and dried chinese broccoli for a comforting, flavorful meal.", "category": "Desktop", "type": "PublicInviteOnly", "freeTrialExpirationDays": 2583, "isActive": false } } ``` **Response** ```json { "result": 7170529050632360, "errorText": "ceno" } ``` **SDK Code** ```python import requests url = "https://ecosystemapi.ninjatrader.com/v1/products" payload = { "product": { "name": "Loretta Goldner", "description": "Hearty marigold and ostrich stew, slow-cooked with spearmint and dried chinese broccoli for a comforting, flavorful meal.", "category": "Desktop", "type": "PublicInviteOnly", "freeTrialExpirationDays": 2583, "isActive": False } } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://ecosystemapi.ninjatrader.com/v1/products'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"product":{"name":"Loretta Goldner","description":"Hearty marigold and ostrich stew, slow-cooked with spearmint and dried chinese broccoli for a comforting, flavorful meal.","category":"Desktop","type":"PublicInviteOnly","freeTrialExpirationDays":2583,"isActive":false}}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://ecosystemapi.ninjatrader.com/v1/products" payload := strings.NewReader("{\n \"product\": {\n \"name\": \"Loretta Goldner\",\n \"description\": \"Hearty marigold and ostrich stew, slow-cooked with spearmint and dried chinese broccoli for a comforting, flavorful meal.\",\n \"category\": \"Desktop\",\n \"type\": \"PublicInviteOnly\",\n \"freeTrialExpirationDays\": 2583,\n \"isActive\": false\n }\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://ecosystemapi.ninjatrader.com/v1/products") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"product\": {\n \"name\": \"Loretta Goldner\",\n \"description\": \"Hearty marigold and ostrich stew, slow-cooked with spearmint and dried chinese broccoli for a comforting, flavorful meal.\",\n \"category\": \"Desktop\",\n \"type\": \"PublicInviteOnly\",\n \"freeTrialExpirationDays\": 2583,\n \"isActive\": false\n }\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://ecosystemapi.ninjatrader.com/v1/products") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"product\": {\n \"name\": \"Loretta Goldner\",\n \"description\": \"Hearty marigold and ostrich stew, slow-cooked with spearmint and dried chinese broccoli for a comforting, flavorful meal.\",\n \"category\": \"Desktop\",\n \"type\": \"PublicInviteOnly\",\n \"freeTrialExpirationDays\": 2583,\n \"isActive\": false\n }\n}") .asString(); ``` ```php request('POST', 'https://ecosystemapi.ninjatrader.com/v1/products', [ 'body' => '{ "product": { "name": "Loretta Goldner", "description": "Hearty marigold and ostrich stew, slow-cooked with spearmint and dried chinese broccoli for a comforting, flavorful meal.", "category": "Desktop", "type": "PublicInviteOnly", "freeTrialExpirationDays": 2583, "isActive": false } }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://ecosystemapi.ninjatrader.com/v1/products"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"product\": {\n \"name\": \"Loretta Goldner\",\n \"description\": \"Hearty marigold and ostrich stew, slow-cooked with spearmint and dried chinese broccoli for a comforting, flavorful meal.\",\n \"category\": \"Desktop\",\n \"type\": \"PublicInviteOnly\",\n \"freeTrialExpirationDays\": 2583,\n \"isActive\": false\n }\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = ["product": [ "name": "Loretta Goldner", "description": "Hearty marigold and ostrich stew, slow-cooked with spearmint and dried chinese broccoli for a comforting, flavorful meal.", "category": "Desktop", "type": "PublicInviteOnly", "freeTrialExpirationDays": 2583, "isActive": false ]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://ecosystemapi.ninjatrader.com/v1/products")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```